/*
 ----------------------------------------------------------------------

   VIRTUOSO (TM) 4.2

   Copyright (c) 1997 - 2001 Wind River Systems, Inc.

   WEB      :    http://www.windriver.com
   Support  :
   * US     :    support@windriver.com
   * Europe :    support-ec@windriver.com


   Filename: $Workfile: iface.h $
   Created by: --------
   Creation date: -----

   Last changes:
   $Archive: /PACS/Simulators/SimSPUv2/iface.h $
   $Revision: 1.2 $
   $Author: amazy $
   $Modtime: 18/06/01 11:17 $


 ----------------------------------------------------------------------
*/

/*
Disable further keyword expansion
$Nokeywords:  $
*/

#ifndef _IFACE_H
#define _IFACE_H

	#include "cputype.h"
	#include "k_types.h"
	#include "k_struct.h"
	#include "k_boot.h"


	#define MON_TSWAP  1
	#define MON_STATE  2
	#define MON_KSERV  4
	#define MON_EVENT  8
	#define MON_ALL   15


	#include "entries.h"
	#include "task.h"
	#include "ticks.h"
	#include "mmap.h"
	#include "res.h"
	#include "mail.h"
	#include "fifo.h"
	#include "sema.h"
	#include "event.h"
	#include "server.h"
	#include "pool.h"
	#include "memcpy.h"
	#include "chan.h"
#ifdef WINNTSIM
    #include "links.h"
#endif

/*---------------------------------------------------------------------------*/
#ifdef __cplusplus
extern "C" {
#endif
/*---------------------------------------------------------------------------*/

	typedef void (*taskstartfunction)(void);
	typedef void (*taskabortfunction)(void);

/* Task Level Debugging */
	extern int K_monitor_mask;
/* Miscellaneous */
	extern void kernel_init (void);
	extern void init_node(void);		/* generated function */
	extern void init_drivers(void);		/* generated function */
	extern void KS_Nop (void);
	extern int  KS_CriticalSection (int (*)(),void *);
	extern const char *KS_KernelVersion (void);
	extern K_NODE K_ThisNode;
	extern int ticktime;
	extern int tickunit;
	extern UNS32 K_KernelPrio;
	extern UNS32 K_DriverPrio;
	extern int K_DataSize;
	extern int K_DataNall;
	extern int K_ArgsNall;
	extern int K_TimerNall;
	extern int K_StackSize;

	extern void* K_DataBlockPtr;
	extern K_ARGS* K_ArgsBlockPtr;
	extern K_TIMER* K_TimerBlockPtr;
	extern void* _minik_stckp;
	extern K_MREC* K_monitor_buff;

	extern const UNS32 MTS_CommBufferSize;
	extern int MTS_RxBuffer[];
	extern int MTS_TxBuffer[];
	extern UNS32* const MTS_PeekPokeBufferPtr;
	extern K_MBOX hostrxmbx;
	extern K_MBOX hosttxmbx;
	extern K_POOL hostrxpool;
	extern K_TASK ppdrv;
	extern K_RES fastchnres;
	extern K_RES hostres;

	extern int K_NumBootPorts;
	extern int K_BootPort;

	extern int K_NodeCount;
	extern int K_PrioCount;
	extern int K_TaskCount;
	extern int K_QueCount;
	extern int K_MapCount;
	extern int K_SemCount;
	extern int K_ResCount;
	extern int K_MbxCount;
	extern int K_PoolCount;
	extern int K_ChanCount;
	extern int K_max_eventnr;
    extern K_PRIO K_PrioCeiling;
    extern int K_monitor_size;

	extern PFN_CHANNEL_RW pHS_Channel_Put;
	extern PFN_CHANNEL_RW pHS_Channel_PutW;
	extern PFN_CHANNEL_RWT pHS_Channel_PutWT;
	extern PFN_CHANNEL_RW pHS_Channel_Get;
	extern PFN_CHANNEL_RW pHS_Channel_GetW;
	extern PFN_CHANNEL_RWT pHS_Channel_GetWT;
	extern PFN_CHANNEL_RWT pKS_Channel_PutWT;
	extern PFN_CHANNEL_RWT pKS_Channel_GetWT;

/*---------------------------------------------------------------------------*/
#ifdef __cplusplus
}
#endif
/*---------------------------------------------------------------------------*/

/* Virtuoso task entry */
#ifdef __cplusplus
#define _VIRTTASK_ENTRY			extern "C"
#else
#define _VIRTTASK_ENTRY
#endif

/* Virtuoso task entry */
#ifdef __cplusplus
#define _EXTERN_DECL			extern "C"
#else
#define _EXTERN_DECL			extern
#endif

#endif /* IFACE_H */

