/*****************************************************************************
 *
 * Project name: 			Plank LFI REBA / Herschel PACS SPU
 * Product name: 			LLSW_DRV
 * Object name: 			l_dsp
 * Filename: 				l_dsp.h
 * Language: 				C (ADSP-21020)
 * Compiler: 				G21K - r3.3
 * Company: 				CRISA
 * Author: 					F. Torrero
 * Version: 				1
 * Creation date: 			06/Aug/2001
 * Last Modification date: 	04/06/2003 16:05:42
 *
 * Description ===============================================================
 *
 * This module implements functions related to DSP21020 registers
 *
 * Change log ===============================================================
 *
 * | DATE 	  | NEW VERSION 	| AUTHOR 	  | 	REASON FOR CHANGE 	|
 * ===========================================================================
 *
 * 06/Aug/01 	1			 	 F.Torrero		Creation
 *
 * ****************************************************************************/ 


#ifndef L_DSP_H
#define L_DSP_H


/*****************************************************************************
   INCLUDES
*****************************************************************************/

#include "l_gendef.h"

/*****************************************************************************
   PROVIDED CONSTANTS
*****************************************************************************/





/*****************************************************************************
   PROVIDED TYPES
*****************************************************************************/


/*****************************************************************************
   PROVIDED VARIABLES
*****************************************************************************/


/*****************************************************************************
   DECLARATION OF PROVIDED FUNCTIONS
*****************************************************************************/

T_SR DSP_EnaDisDSPGlobalInt(T_UNSIGNED_32 EnableDisableFlag);

T_SR DSP_MaskUnmaskDSPInt(T_UNSIGNED_32 InterruptBitMask,
						  T_UNSIGNED_32 MaskUnmaskFlag);

T_UNSIGNED_32 DSP_GetDSPGlobalIntStatus(T_VOID);

T_SR DSP_GetDSPIMR(T_UNSIGNED_32 *InterruptMaskRegValue);

T_SR DSP_GetDSPIPR(T_UNSIGNED_32 *InterruptPendingRegValue);

T_SR DSP_ClearDSPIPR(T_VOID);

T_VOID DSP_ClearDSPInt(T_UNSIGNED_32 InterruptBitMask);

T_SR DSP_GetDSPSTKY(T_UNSIGNED_32 *STKYRegValue);

T_SR DSP_ClearDSPSTKY(T_VOID);

T_SR DSP_EnaDisDSPFloatTRUNC(T_UNSIGNED_32 EnableDisableFlag);



#endif  /* L_DSP_H */

