/*****************************************************************************
 *
 * Project name: 			Plank LFI REBA / Herschel PACS SPU
 * Product name: 			LLSW_DRV
 * Object name: 			l_gendef
 * Filename: 				l_gendef.h
 * Language: 				C (ADSP-21020)
 * Compiler: 				G21K - r3.3
 * Company: 				CRISA
 * Author: 					Jaime Gomez/F. Torrero
 * Version: 				1
 * Creation date: 			03/Aug/2001
 * Last Modification date: 	04/06/2003 16:05:44
 *
 * Description ===============================================================
 *
 * This module defines common types and constants to be used throughout 
 * the project
 *
 * Change log ===============================================================
 *
 * | DATE 	  | NEW VERSION 	| AUTHOR 	  | 	REASON FOR CHANGE 	|
 * ===========================================================================
 *
 * 03/Aug/01 	1			 	 J. Gmez		Creation
 *
 * ****************************************************************************/ 


#ifndef L_GENDEF_H
#define L_GENDEF_H


/*****************************************************************************
   PROVIDED CONSTANTS
*****************************************************************************/


/* Boolean TRUE/FALSE constants */
#define K_TRUE	1
#define K_FALSE	0

/* To be used as function parameters */
#define K_ENABLE	1	
#define K_DISABLE	0	

#define K_MASK		0	
#define K_UNMASK	1

#define K_HIGH	1
#define K_LOW	0


/* To be used in infinite "for" loops */
#define EVER (;;)



/*****************************************************************************
   PROVIDED TYPES
*****************************************************************************/

typedef int T_SIGNED_32;

typedef int T_SIGNED_16;

typedef unsigned int T_UNSIGNED_32;

typedef unsigned int T_UNSIGNED_16;

typedef T_UNSIGNED_32 T_BOOLEAN;	/* To be used with TRUE/FALSE values */

typedef T_UNSIGNED_32 T_LEVEL;	/* To be used with K_HIGH/K_LOW values */

typedef T_UNSIGNED_32 T_SR; /* Status return */

typedef void T_VOID;

typedef float T_FLOAT; 



/*****************************************************************************
   PROVIDED VARIABLES
*****************************************************************************/


/*****************************************************************************
   DECLARATION OF PROVIDED FUNCTIONS
*****************************************************************************/



#endif  /* L_GENDEF_H */

