/*****************************************************************************
 *
 * Project name: 			Plank LFI REBA / Herschel PACS SPU
 * Product name: 			LLSW_DRV
 * Object name: 			l_smcsre
 * Filename: 				l_smcsre.h
 * Language: 				C (ADSP-21020)
 * Compiler: 				G21K - r3.3
 * Company: 				CRISA
 * Author: 					F. Torrero
 * Version: 				1
 * Creation date: 			25/Apr/2001
 * Last Modification date: 	04/06/2003 16:05:46
 *
 * Description ===============================================================
 *
 * This module implements reset and stop functions for SMCS chip
 *
 * Change log ===============================================================
 *
 * | DATE 	  | NEW VERSION 	| AUTHOR 	  | 	REASON FOR CHANGE 	|
 * ===========================================================================
 *
 * 25/Apr/01 	1			 	 F.Torrero		Creation
 *
 * ****************************************************************************/ 


#ifndef L_SMCSRE_H
#define L_SMCSRE_H


/*****************************************************************************
   INCLUDES
*****************************************************************************/

#include "l_gendef.h"

/*****************************************************************************
   PROVIDED CONSTANTS
*****************************************************************************/



/*****************************************************************************
   PROVIDED TYPES
*****************************************************************************/


/*****************************************************************************
   PROVIDED VARIABLES
*****************************************************************************/


/*****************************************************************************
   DECLARATION OF PROVIDED FUNCTIONS
*****************************************************************************/

T_SR SMCS_ResetChannelTxSection(T_UNSIGNED_32 Channel);

T_SR SMCS_ResetChannelRxSection(T_UNSIGNED_32 Channel);

T_SR SMCS_ResetSMCSChip(T_VOID);

T_SR SMCS_StopChannel(T_UNSIGNED_32 Channel);



#endif  /* L_SMCSRE_H */

