/*****************************************************************************
 *
 * Project name: 			Plank LFI REBA / Herschel PACS SPU
 * Product name: 			LLSW_DRV
 * Object name: 			l_smcstr
 * Filename: 				l_smcstr.h
 * Language: 				C (ADSP-21020)
 * Compiler: 				G21K - r3.3
 * Company: 				CRISA
 * Author: 					F. Torrero
 * Version: 				1
 * Creation date: 			05/Jul/2001
 * Last Modification date: 	04/06/2003 16:05:48
 *
 * Description ===============================================================
 *
 * This module implements the transmission/reception functions for SMCS chip
 *
 * Change log ===============================================================
 *
 * | DATE 	  | NEW VERSION 	| AUTHOR 	  | 	REASON FOR CHANGE 	|
 * ===========================================================================
 *
 * 05/Jul/01 	1			 	 F.Torrero		Creation
 *
 * ****************************************************************************/ 


#ifndef L_SMCSTR_H
#define L_SMCSTR_H


/*****************************************************************************
   INCLUDES
*****************************************************************************/

#include "l_gendef.h"

/*****************************************************************************
   PROVIDED CONSTANTS
*****************************************************************************/

/* End of packet token identifiers */
#define K_EOP1		1
#define K_EOP2		2


/*****************************************************************************
   PROVIDED TYPES
*****************************************************************************/


/*****************************************************************************
   PROVIDED VARIABLES
*****************************************************************************/


/*****************************************************************************
   DECLARATION OF PROVIDED FUNCTIONS
*****************************************************************************/

T_SR SMCS_StartChannelAsMaster(T_UNSIGNED_32 Channel);

T_SR SMCS_StartChannelAsSlave(T_UNSIGNED_32 Channel);

T_SR SMCS_TransmitBuffer(T_UNSIGNED_32 Channel,
						 T_UNSIGNED_32 EndOfPacketType,
						 T_UNSIGNED_32 PacketStartAddress,
						 T_UNSIGNED_32 PacketLength);

T_SR SMCS_ReceiveBuffer(T_UNSIGNED_32 Channel,
						T_UNSIGNED_32 PacketStartAddress,
						T_UNSIGNED_32 PacketLength);

T_SR SMCS_GetCurrentTxAddress(T_UNSIGNED_32 Channel,
							  T_UNSIGNED_32 *TxCurrentAddress);

T_SR SMCS_GetCurrentRxAddress(T_UNSIGNED_32 Channel,
							  T_UNSIGNED_32 *RxCurrentAddress);

T_SR SMCS_GetChannelStatus(T_UNSIGNED_32 Channel,
						   T_UNSIGNED_32 *CHx_DSM_STARRegisterValue);

T_SR SMCS_GetSMCSErrorSourceReg1(T_UNSIGNED_32 Channel,
								 T_UNSIGNED_32 *CHx_ESR1RegisterValue);

T_SR SMCS_GetReceivedDataSize(T_UNSIGNED_32 Channel,
							  T_UNSIGNED_32 *ReceivedDataSize);



#endif  /* L_SMCSTR_H */

