/*
 ----------------------------------------------------------------------

   VIRTUOSO (TM) 4.2

   Copyright (c) 1997 - 2001 Wind River Systems, Inc.

   WEB      :    http://www.windriver.com
   Support  :
   * US     :    support@windriver.com
   * Europe :    support-ec@windriver.com


   Filename: $Workfile: macro.h $
   Created by: --------
   Creation date: -----

   Last changes:
   $Archive: /virt_4_2/Adi21020/inc/macro.h $
   $Revision: 1.1 $
   $Author: roland $
   $Modtime: 30-05-01 10:07a $


 ----------------------------------------------------------------------
*/

/*
Disable further keyword expansion
$Nokeywords:  $
*/

#ifndef MACRO_H
#define MACRO_H


/* OLD PRHI Function calling macros, converted to new for compatibility */

#define PRHI_SIG	call __prhi_sema_sig(db);	\
							bit clr MODE1 IRPTEN;		\
							r0 = 0;

#define PRHI_PSH	call __prhi_stack_psh(db);	\
							bit clr MODE1 IRPTEN;		\
							r0 = 0;

#define PRHI_PUT	call __prhi_lifo_put(db);	\
							bit clr MODE1 IRPTEN;		\
							r0 = 0;

#define PRHI_WAIT	call __prhi_sema_tstw(db);	\
						 	bit clr MODE1 IRPTEN;		\
						 	r0 = 0;

#define PRHI_POPW	call __prhi_stack_popw(db);	\
						 	bit clr MODE1 IRPTEN;		\
						 	r0 = 0;

#define PRHI_POP	call __prhi_stack_pop(db);	\
							bit clr MODE1 IRPTEN;		\
							r0 = 0;

#define PRHI_GETW 	call __prhi_lifo_getw(db);	\
								bit clr MODE1 IRPTEN;		\
								r0 = 0;

#define PRHI_GET  	call __prhi_lifo_get(db);	\
								bit clr MODE1 IRPTEN;		\
								r0 = 0;



/* NEW PRHI calling macro's */

				/* SEMAPHORE CHANNELS */

#define PRHI_SEMA_SIG		call __prhi_sema_sig(db);	\
								  		bit clr MODE1 IRPTEN;		\
								  		r0 = 0;

#define PRHI_SEMA_TST		call __prhi_sema_tst(db);	\
								  		bit clr MODE1 IRPTEN;		\
								  		r0 = 0;

#define PRHI_SEMA_TSTW		call __prhi_sema_tstw(db);	\
								  		bit clr MODE1 IRPTEN;		\
								  		r0 = 0;

				/* LIFO CHANNELS */

#define PRHI_LIFO_PUT		call __prhi_lifo_put(db);	\
										bit clr MODE1 IRPTEN;		\
										r0 = 0;

#define PRHI_LIFO_GET		call __prhi_lifo_get(db);	\
										bit clr MODE1 IRPTEN;		\
										r0 = 0;

#define PRHI_LIFO_GETW		call __prhi_lifo_getw(db);	\
										bit clr MODE1 IRPTEN;		\
										r0 = 0;

				/* STACK CHANNELS */

#define PRHI_STACK_PSH		call __prhi_stack_psh(db);	\
										bit clr MODE1 IRPTEN;		\
										r0 = 0;

#define PRHI_STACK_POP		call __prhi_stack_pop(db);	\
										bit clr MODE1 IRPTEN;		\
										r0 = 0;

#define PRHI_STACK_POPW		call __prhi_stack_popw(db);	\
										bit clr MODE1 IRPTEN;		\
										r0 = 0;


				/* MWFIFO CHANNELS */

#define PRHI_MWFIFO_GET		call __prhi_mwfifo_get(db);	\
							  			bit clr MODE1 IRPTEN;		\
							  			r4 = i4;

#define PRHI_MWFIFO_GETW	call __prhi_mwfifo_getw(db);\
							  			bit clr MODE1 IRPTEN;		\
							  			r4 = i4;

#define PRHI_MWFIFO_PUT		call __prhi_mwfifo_put(db);	\
							  			bit clr MODE1 IRPTEN;		\
							  			r4 = i4;


/* ISR routine save/restore registers macros */
/* MODE1 is set to default */
#ifdef POW 
	#define START_ISR	dm(i7,m7) = r0;\
						dm(i7,m7) = r1;			\
						dm(i7,m7) = r2;			\
						dm(i7,m7) = r4;			\
						dm(i7,m7) = r8;			\
						dm(i7,m7) = r12;		\
						r4 = i4;				\
						dm(i7,m7) = r4;			\
						dm(i7,m7) = i12;		\
						r0 = dm(_BBCCMDpowoff); \
						i12 = 0xfffffa;			\
						pm(3,i12) = r0;			\
						pmwait = dm(_pmwaitvalue); /* restore pmwait from memory */
															/* power save off */

#else
	#define START_ISR	dm(i7,m7) = r0;\
						dm(i7,m7) = r1;			\
						dm(i7,m7) = r2;			\
						dm(i7,m7) = r4;			\
						dm(i7,m7) = r8;			\
						dm(i7,m7) = r12;		\
						r4 = i4;				\
						dm(i7,m7) = r4;			\
						dm(i7,m7) = i12;

#endif

	#define END_ISR		r0 = ASTAT;				\
						r1 = dm(9,i7);			\
						r2 = 0x00780000;		\
						r0 = r0 and r2;			\
						r2 = not r2;			\
						r1 = r1 and r2;			\
						r0 = r0 or r1;			\
						dm(9,i7) = r0;			\
						i12 = dm(1,i7); 		\
						i4  = dm(2,i7); 		\
						r12 = dm(3,i7); 		\
						r8  = dm(4,i7); 		\
						r4  = dm(5,i7); 		\
						r2  = dm(6,i7); 		\
						r1  = dm(7,i7); 		\
						r0  = dm(8,i7); 		\
						ASTAT = dm(9,i7); 		\
						rti (db,lr) ;			\
						MODE1 = dm(10,i7); 		\
						modify (i7,10);

/* nanokernel - microkernel internals */

	#define SWAP		call __nanok_swap(db);	\
				  		bit clr MODE1 IRPTEN;	\
				  		r0 = 0;

	#define SWAPH		call __nanok_swaph(db);	\
				  		bit clr MODE1 IRPTEN;	\
				  		nop;

	#define SWAPL		call __nanok_swapl(db);	\
				  		bit clr MODE1 IRPTEN;	\
				  		i4 = _nanok_data;

	#define YIELD		call __nanok_yield(db);	\
				  		bit clr MODE1 IRPTEN;	\
				  		nop;

	#define ENDISR1		jump __end_isr1(db);	\
				  		bit clr MODE1 IRPTEN;	\
				  		i4 = _nanok_data;

	#define PRLO_PSH  	r2=i6; \
						i6=i7; \
						jump _prlo_stack_psh(db);	\
						dm(i7,m7) = r2;	\
						dm(i7,m7) = pc;
#endif

