/***************************************************************************************
* File name: spu_io.h
* Version.Revision: HPSPU-HLSW-OB-V8R3
*
* Public Functions: None
*
* Private Functions: None
*
* Description:	This Header File Contains the Crisa Drivers and Constants to 
*				Be Used by the spu_io.c for SMCS IO Handling.
*
* Short Description: Include CRISA Library
*
* Creation date & author: 08.07.2002 by Ahmed Nabil Belbachir
* Version, Update date & author: HPSPU-HLSW-OB-V8R3 01.03.2004 by Ahmed Nabil Belbachir
****************************************************************************************/

/* Declaration of the Header File 
===================================================================================================*/

#ifndef _spu_io_H
#define _spu_io_H

/*===========================================================================================================*/
/* The Header Files 
===================================================================================================*/

#include "node1.h"
#include "l_hwmap.h"  
#include "l_gendef.h"
#include "l_errcod.h" 
#include "spulib.h"
/* ---------------------------------------------- */
/* CRISA Drivers                                  */
/* ---------------------------------------------- */

/* DSP driver */
#include "l_dsp.h" 

/* SMCS driver */
#include "l_smcsge.h"
#include "l_smcsco.h"
#include "l_smcsre.h"
#include "l_smcsin.h"
#include "l_smcstr.h"

/* EDAC driver */
#include "l_edac.h"

/* Miscellaneous driver */
#include "l_pscint.h"
#include "l_memory.h"

/*===========================================================================================================*/
/* Initialization of the Parameters 
=============================================================================================================*/

#define K_DMADDR_DPUCOMMAND			K_DMADDR_BASE_SMCSDPRAM			/* Address to Receive DPU Commands*/
#define K_DMADDR_ACKTODPU			K_DMADDR_BASE_SMCSDPRAM + 0x500	/* Address where Packets to DPU are Put */
#define K_DMADDR_DMCDATA			K_DMADDR_BASE_SMCSDPRAM + 0x1000/* Address to Receive DEC/MEC Packets */
#define K_DMADDR_ACKTODMC			K_DMADDR_BASE_SMCSDPRAM + 0x1C00/* Address where Packets to DEC/MEC are Put */
#define K_DMADDR_L3DATA				K_DMADDR_BASE_SMCSDPRAM + 0x1E00/* Address to Receive Link 3 Packets */
#define K_DMADDR_ACKLINK3			K_DMADDR_BASE_SMCSDPRAM + 0x1F00/* Address where Packets to Link 3 are Put */
#define K_1355_MAX_PACKET_LENGTH        280								/* Max Nb of Words to Read/write from/to a Link*/
#define K_DPU_LINK_CONNECTION_TIMEOUT	9000							/* 9 sec Time Out to wait that DPU Link is ON */
#define K_DMC_LINK_CONNECTION_TIMEOUT	600000000						/* Infinite Wait Time Out that DMC Link is ON */
#define REPORT_BADADDR				0x000034B0						/* Address for Temporary Bad Address Report */
/*===========================================================================================================*/

#endif